<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://xmlns.jcp.org/jsf/html"
      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
      xmlns:b="http://bootsfaces.net/ui"
      xmlns:f="http://xmlns.jcp.org/jsf/core"
>

<ui:composition template="WEB-INF/compatible-template.xhtml">
    <ui:define name="pageContent">

        <b:container>
            <div class="formPanel customRows2">

                <b:form>
                    <b:commandButton value="Add flight" look="success" icon="edit" styleClass="editButtonClass"
                                     size="lg" action="#{flightCreationBean.viewAddFlight()}"
                                     rendered="#{currentUser.currentUserRole == 'PARTNER'}"/>
                </b:form>
                <br/>

                <b:dataTable value="#{flightCreationBean.getAllFlights()}" var="flight">

                    <b:dataTableColumn>
                        <f:facet name="header">Route</f:facet>
                        <h:outputText value="#{flight.getFlightRoute().toString()}"/>
                    </b:dataTableColumn>

                    <b:dataTableColumn>
                        <f:facet name="header">Departure</f:facet>
                        <h:outputText value="#{flight.getDepartureLocalDateTime()}"
                                      converter="realdolmen.dateTimeConverter"/>
                    </b:dataTableColumn>

                    <b:dataTableColumn>
                        <f:facet name="header">Arrival</f:facet>
                        <h:outputText value="#{flight.getArrivalLocalDateTime()}"
                                      converter="realdolmen.dateTimeConverter"/>
                    </b:dataTableColumn>

                    <b:dataTableColumn>
                        <f:facet name="header">Airline</f:facet>
                        <h:outputText value="#{flight.getAirline().getName()}"/>
                    </b:dataTableColumn>

                    <b:dataTableColumn>
                        <f:facet name="header"> Luxury settings </f:facet>
                        <h:form>
                            <b:commandButton value="Details" look="info" size="sm"
                                             action="#{flightCreationBean.viewLuxuryDetails(flight.id)}"/>
                        </h:form>
                    </b:dataTableColumn>

                    <b:dataTableColumn>
                        <f:facet name="header"> Volume Discounts </f:facet>
                        <h:form>
                            <b:commandButton value="Details" look="info" size="sm"
                                             action="#{flightCreationBean.viewDiscountDetails(flight.id)}"/>
                        </h:form>
                    </b:dataTableColumn>

                    <b:dataTableColumn rendered="#{currentUser.currentUserRole == 'PARTNER'}">
                        <f:facet name="header"> Edit </f:facet>
                        <h:form>
                            <b:commandButton value="Edit" icon="edit" size="sm"
                                             action="#{flightCreationBean.viewEditFlight()}"/>
                        </h:form>
                    </b:dataTableColumn>
                </b:dataTable>


                <!--scripting 4 popups-->

                <script type="text/javascript">
                    $(function () {
                        if ("#{flightCreationBean.edit}" != "false") $('#editFlightPopup').modal();
                        if ("#{flightCreationBean.add}" != "false") $('#addFlightPopup').modal();
                        if ("#{flightCreationBean.detailsLuxury}" != "false") $('#detailsLuxuryPopup').modal();
                        if ("#{flightCreationBean.detailsDiscounts}" != "false") $('#detailsDiscountPopup').modal();
                    });
                </script>

            </div>
        </b:container>

        <!--flight adding popup-->

        <b:modal id="addFlightPopup" title="Add Flight"
                 styleClass="responsiveModalPseudoClass">
            <b:form id="addFlight">
                    <b:column span="6">
                        <b:dateTimePicker value="#{flightCreationBean.flight.departureLocalDateTime}"
                                          converter="realdolmen.dateTimeConverter"
                                          format="DD/MM/YYYY HH:mm"
                                          label="Departure date/time"
                                          minDate="#{dateBean.today()}"
                                          required="true"/>
                        <b:inputText value="#{routeSearchBean.from}" update="selectRoute"
                                     label="From (airport code/name/country)"/>
                    </b:column>
                    <b:column span="6">
                        <b:dateTimePicker value="#{flightCreationBean.flight.departureLocalDateTime}"
                                          converter="realdolmen.dateTimeConverter"
                                          format="DD/MM/YYYY HH:mm"
                                          label="Arrival date/time"
                                          minDate="#{dateBean.today()}"
                                          required="true"/>
                        <b:inputText value="#{routeSearchBean.to}" update="selectRoute"
                                     label="To (airport code/name/country)"/>
                    </b:column>
                    <b:column span="12">
                        <b:selectOneMenu id="selectRoute" value="#{flightCreationBean.flight.flightRoute}"
                                         ajax="true"
                                         process="@this"
                                         label="Selecht route based on origin and destination" required="true">
                            <f:selectItems value="#{routeSearchBean.getRoutesBySetStringParams()}" var="route"
                                           itemValue="#{route}" itemLabel="#{route.toString()}"/>
                        </b:selectOneMenu>
                    </b:column>

                    <b:column span="6">
                        <b:inputText value="#{flightCreationBean.luxuryWithCapacityAndPrices.numberOfSeats}"
                                     placeholder="Capacity" label="Economy"
                                     required="true"/>
                        <b:inputText value="#{flightCreationBean.luxuryWithCapacityAndPrices.askingPrice}"
                                     placeholder="Base price"
                                     required="true"/>
                        <b:column span="6">
                            <b:inputText value="#{flightCreationBean.volumeDiscount.nbOfSeatForThisDicscount}"
                                         placeholder="Nb. seats"
                                         label="Volume discount 1"/>
                            <b:inputText value="#{flightCreationBean.volumeDiscount.purcentage}"
                                         placeholder="Discount"
                            />

                        </b:column>
                        <b:column span="6">
                            <b:inputText value="#{flightCreationBean.volumeDiscount2.nbOfSeatForThisDicscount}"
                                         placeholder="Nb. of seats"
                                         label="Volume discount 2"/>
                            <b:inputText value="#{flightCreationBean.volumeDiscount2.purcentage}"
                                         placeholder="Discount"
                            />
                        </b:column>

                    </b:column>
                    <b:column span="6">
                        <b:inputText value="#{flightCreationBean.luxuryWithCapacityAndPrices1.numberOfSeats}"
                                     placeholder="Capacity" label="First class"/>
                        <b:inputText value="#{flightCreationBean.luxuryWithCapacityAndPrices1.askingPrice}"
                                     placeholder="Base price"/>
                        <b:selectBooleanCheckbox value="#{flightCreationBean.repeat}" caption="Repeat daily"
                                                 label="Schedule flight"/>
                        <b:selectBooleanCheckbox value="#{flightCreationBean.repeatweekly}" caption="Repeat weekly"/>
                        <b:dateTimePicker value="#{flightCreationBean.repeatTill}"
                                          converter="realdolmen.dateConverter"
                                          format="DD/MM/YYYY"
                                          minDate="#{dateBean.today()}"/>
                    </b:column>

                    <b:column span="12">
                        <h:outputText val=""/>
                    </b:column>
                <div class="modal-footer">

                    <b:button value="Close" dismiss="modal" style="float:left;"/>


                    <b:commandButton style="float:right;" value="Create" look="primary" dismiss="modal"
                                     action="#{flightCreationBean.createFlight()}"/>
                </div>
            </b:form>

        </b:modal>

        <!--edit flight popup-->

        <b:modal id="editFlightPopup" title="Edit flight information" styleClass="modalPseudoClass">
            <b:form id="editFlight">

            </b:form>
        </b:modal>

        <!--details luxury popup-->

        <b:modal id="detailsLuxuryPopup" title="Luxury class details" styleClass="responsiveModalPseudoClass">
            <h:form id="editLuxury">
                <b:dataTable value="#{flightCreationBean.searchLuxuryDetails()}" var="detail"
                             class="luxTabClass"
                             responsive="true" scroll-horizontally="true">
                    <b:dataTableColumn label="Luxury class" value="#{detail.flightQuality}"/>
                    <b:dataTableColumn label="Remaining seats" value="#{detail.numberOfSeats}"/>
                    <b:dataTableColumn label="Base price" value="#{detail.basePrice}"/>
                    <b:dataTableColumn label="Asking price" value="#{detail.askingPrice}">
                        <h:outputText value="#{detail.askingPrice}"
                                      rendered="#{flightCreationBean.editLuxury}"/>

                    </b:dataTableColumn>
                    <b:dataTableColumn label="Edit" rendered="#{currentUser.currentUserRole == 'EMPLOYEE'}">
                        <h:inputText binding="#{floatValue}" placeholder="#{detail.askingPrice}"/>
                        <b:commandButton icon="edit" value="Update asking price" look="info" update="@form"
                                         onclick="ajax:flightCreationBean.updateLuxuryClass(detail.id,floatValue.value)"
                        />
                    </b:dataTableColumn>
                </b:dataTable>
                <b:button value="Close" dismiss="modal"/>
            </h:form>
        </b:modal>

        <!--Discount popup-->

        <b:modal id="detailsDiscountPopup" title="Volume discount details"
                 styleClass="responsiveModalPseudoClass">
            <b:form id="editDiscount">
                <b:commandButton value=" Add/Update" look="success" icon="edit" size="sm"
                                 style="margin-bottom:1em"
                                 rendered="#{currentUser.currentUserRole == 'EMPLOYEE'}"
                />
                <br/>
                <b:dataTable value="#{flightCreationBean.searchDiscountDetails()}" var="discount"
                             widgetVar="tableWidgetVar" responsive="true" scroll-horizontally="true">
                    <b:dataTableColumn label="Required nb. of seats">
                        <h:outputText value="#{discount.nbOfSeatForThisDicscount}"/>
                    </b:dataTableColumn>
                    <b:dataTableColumn label="Discount">
                        <h:outputText value="#{discount.purcentage*100} \%"/>
                    </b:dataTableColumn>
                    <b:dataTableColumn label="Delete" rendered="#{currentUser.currentUserRole == 'EMPLOYEE'}">
                        <b:commandButton value="Delete" look="danger" id="delDisc"
                                         action="#{flightCreationBean.deleteDiscount(discount)}"/>
                    </b:dataTableColumn>
                </b:dataTable>
            </b:form>
        </b:modal>

    </ui:define>
</ui:composition>

<style type="text/css">
    .editButtonClass {
        margin-bottom: 1em
    }

</style>

</html>